/* -*- Mode: C; indent-tabs-mode: t; c-basic-offset: 4; tab-width: 4 -*- */
/*
 * trunk
 * Copyright (C) Eoin McMahon 2010 <eoinmcmahon0@AT@gmail.com>
 * 
 * trunk is free software: you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * trunk is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef _CONNECTION_HPP_
#define _CONNECTION_HPP_


#include "model-row.hpp"
#include "view-row.hpp"



class Connection
{
public:
	
		Connection();
		~Connection();
	
		// typedef signal types
		typedef sigc::signal< vbM_WIDTH_RETURN , vbM_WIDTH_PARAM >
			sig_type_width;
		
		typedef sigc::signal< vbM_SENSITIVITY_RETURN , vbM_SENSITIVITY_PARAM > 
			sig_type_sensitivity;
		
		typedef sigc::signal< vbM_ROW_RETURN , vbM_ROW_PARAM > 
			sig_type_row;
		
		typedef sigc::signal< vbM_VALUE_BOO_RETURN , vbM_VALUE_BOO_PARAM >
			sig_type_value_BOO;
		
		typedef sigc::signal< vbM_VALUE_STR_RETURN , vbM_VALUE_STR_PARAM >
			sig_type_value_STR;
		
		
		
		
		// typedef pairs for lists of these types
		typedef pair<Gtk::HBox *,  sigc::connection > pair_type_width;
		typedef pair<ViewRow::ViewRow *,  sigc::connection > pair_type_sensitivity;
		typedef pair<Gtk::VBox *,  sigc::connection > pair_type_row;
		typedef pair<ModelRow::ModelRow *,  sigc::connection > pair_type_value_BOO;
		typedef pair<ModelRow::ModelRow *,  sigc::connection > pair_type_value_STR;
		
		//typedef maps for lists of these types
		typedef std::map<Gtk::HBox *,  sigc::connection > map_type_width;
		typedef std::map<ViewRow::ViewRow *,  sigc::connection > map_type_sensitivity;
		typedef std::map<Gtk::VBox *,  sigc::connection > map_type_row;
		typedef std::map<ModelRow::ModelRow *,  sigc::connection > map_type_value_BOO;
		typedef std::map<ModelRow::ModelRow *,  sigc::connection > map_type_value_STR;
		
		// typedef iterators for these maps
		typedef map_type_width::iterator it_type_width;
		typedef map_type_sensitivity::iterator it_type_sensitivity;
		typedef map_type_row::iterator it_type_row;
		typedef map_type_value_BOO::iterator it_type_value_BOO;
		typedef map_type_value_STR::iterator it_type_value_STR;
		
		/*
		 // 
	 // So a list of connections to a viewrow is declared as :
		 // map_type_width width_changed_conn_map;
	 // A connection is made by : 
		 // width_changed_conn_map.insert(pair_type_width(viewrow , sigc::connect
		 // 				(sigc::memfun(&<receiving_instance> , on_width_changed))));
		 //
	 // A connection is deleted by:
		 //
		 // it_type_width it = width_changed_conn_map.find(&viewrow);
		 // if (it != width_changed_conn_map.end())
		 // {
		 // 	sigc::connection(it->second).disconnect();
		 // 	width_changed_conn_map.erase(it->first);
		 // }
		 // 
		 */
		
		
						   
protected:

private:

};

#endif // _CONNECTION_HPP_
