/* -*- Mode: C; indent-tabs-mode: t; c-basic-offset: 4; tab-width: 4 -*- */
/*
 * trunk
 * Copyright (C) Eoin McMahon 2010 <eoinmcmahon0@AT@gmail.com>
	 * 
 * trunk is free software: you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
	 * 
 * trunk is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef _DATA_HPP_
#define _DATA_HPP_

#include <glib.h>
#include <iostream>
#include <vector>
#include <map>
#include <list>
#include <time.h>
#include <gtkmm.h>
#include <libglademm/xml.h>
#include <gconfmm.h>

#define vbM_WIDTH_RETURN void
#define vbM_WIDTH_PARAM clock_t, Data::STR, std::vector<int> & , int 
#define vbM_SENSITIVITY_RETURN void
#define vbM_SENSITIVITY_PARAM std::vector<bool>
#define vbM_ROW_RETURN void
#define vbM_ROW_PARAM clock_t, Data::STR, ModelRow::ModelRow &
#define vbM_VALUE_BOO_RETURN void
#define vbM_VALUE_BOO_PARAM clock_t, Data::STR, Data::m_b_col, Data::BOO, Data::BOO
#define vbM_VALUE_STR_RETURN void
#define vbM_VALUE_STR_PARAM clock_t, Data::STR, Data::m_s_col, Data::STR, Data::STR

using namespace std;
class Data
{
	public:
		
		typedef Glib::ustring STR;
		typedef bool BOO;
		enum type
	{
		STR_,
		BOO_
	};
		
		static const int n_m_s_cols ;
		static const int n_m_b_cols ;
		static const int n_m_cols ;
		static const int n_v_s_cols ;
		static const int n_v_b_cols ;
		static const int n_v_cols;
		
		enum m_s_col
	{
		uuid,
		name,
		status,
		port,
		autostartstatus
	};
		
		enum m_b_col
	{
		start,
		acpi,
		kill,
		save,
		pause,
		resume,
		console,
		autostart
	};
		
		enum v_s_col
	{
		vname,
		vstatus,
		vport
	};
		
		enum v_b_col
	{
		vstart,
		vconsole,
		vacpi,
		vkill,
		vpause,
		vsave,
		vautostart
	};
		
		
		typedef pair<pair<type,v_s_col>,pair<type,m_s_col> > STRmap;
		typedef pair<pair<type,v_b_col>,pair<type,m_b_col> > BOOmap;
	
		
	protected:
	
	private:
	
};



#endif // _DATA_HPP_
