/* -*- Mode: C; indent-tabs-mode: t; c-basic-offset: 4; tab-width: 4 -*- */
/*
 * trunk
 * Copyright (C) Eoin McMahon 2010 <eoinmcmahon0@AT@gmail.com>
 * 
 * trunk is free software: you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * trunk is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include "derived-window.hpp"

using namespace std;


DerivedWindow::DerivedWindow(BaseObjectType * cobject,
							 const Glib::RefPtr<Gnome::Glade::Xml> & refGlade)
: Gtk::Window(cobject)
{
}

bool DerivedWindow::on_delete_event(GdkEventAny * event)
{
//	cout << "Window delete event"<< endl;
	return false;
}


void DerivedWindow::on_hide()
{
	int x,y;
		Gtk::Allocation a = this->get_allocation();
		this->get_position(x,y);
		a.set_x(x);
		a.set_y(y);
	gconfclient->set("/apps/vbmanage/mainwindow/xpos",a.get_x());
	gconfclient->set("/apps/vbmanage/mainwindow/ypos",a.get_y());
	gconfclient->set("/apps/vbmanage/mainwindow/width",a.get_width());
	gconfclient->set("/apps/vbmanage/mainwindow/height",a.get_height());
	
	std::string mcline;
	ofstream vbmanage_conf ("vbManage.conf", ios::out);
		if (vbmanage_conf.is_open())
		{
			vbmanage_conf << a.get_x() <<","<< a.get_y() << ";" <<
				a.get_width() << ":" << a.get_height() <<endl;
			//~ cout << a.get_x() <<","<< a.get_y() << ";" <<
				//~ a.get_width() << ":" << a.get_height() <<endl;
			vbmanage_conf.close();
		}
		else
		{
			cout << "Could not open config file" << endl;
		}
	
	//cout << "Window hide called" << endl;
}
