/* -*- Mode: C; indent-tabs-mode: t; c-basic-offset: 4; tab-width: 4 -*- */
/*
 * trunk
 * Copyright (C)  2010 <>
	 * 
 * trunk is free software: you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
	 * 
 * trunk is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef _MODEL_ROW_HPP_
#define _MODEL_ROW_HPP_



#include <glib.h>
#include <iostream>
#include <vector>
#include <map>
#include <list>
#include <time.h>
#include <gtkmm.h>
#include <libglademm/xml.h>
#include <sigc++/sigc++.h>
#include "data.hpp"

class ModelRow : public Data
{
	public:
		friend class View;
		size_t index;
		STR myuuid;
		vector<STR> m_s_cols;
		vector<BOO> m_b_cols;
		ModelRow();
		ModelRow(Data::STR & IPaddress);
		
		class changed_str_record
	{
		public:
			clock_t timestamp_;
			Data::STR uuid_;
			Data::m_b_col col_;
			Data::STR oldvalue_;
			Data::STR newvalue_;
	};
		
		class changed_boo_record
	{
		public:
			clock_t timestamp_;
			Data::STR uuid_;
			Data::m_b_col col_;
			Data::BOO oldvalue_;
			Data::BOO newvalue_;
	};
		list<changed_str_record> changed_str_list;
		list<changed_boo_record> changed_boo_list;
		typedef sigc::signal<void, clock_t, Data::STR, m_b_col, Data::BOO, Data::BOO>
			type_BOO_changed_signal;
		type_BOO_changed_signal BOO_changed_signal();
		typedef sigc::signal<void, clock_t, Data::STR, m_s_col, Data::STR, Data::STR>
			type_STR_changed_signal;
		type_STR_changed_signal STR_changed_signal();
		Data::STR parent_host_address;
		
		STR get_str_value(m_s_col col);
		BOO get_boo_value(m_b_col col);
		void set_str_value(m_s_col col, STR value);
		void set_boo_value(m_b_col col, BOO value);
		vector<STR>::iterator get_str_iterator();
		vector<BOO>::iterator get_boo_iterator();
		virtual void emit_row_changed_STR(clock_t timestamp,
								  STR uuid,
								  m_s_col col,
								  STR old,
								  STR newvalue);
		virtual void emit_row_changed_BOO(clock_t timestamp,
								  STR uuid,
								  m_b_col col,
								  BOO old,
								  BOO newvalue);
	protected:
		clock_t get_timestamp();
		type_STR_changed_signal m_STR_changed_signal;
		type_BOO_changed_signal m_BOO_changed_signal;
		void on_row_changed_STR_ack(clock_t timestamp,
									STR uuid,
									m_s_col col,
									STR old,
									STR newvalue);
		void on_row_changed_BOO_ack(clock_t timestamp,
									STR uuid,
									m_b_col col,
									BOO old,
									BOO newvalue);
		
		
};

#endif // _MODEL_ROW_HPP_
