/* -*- Mode: C; indent-tabs-mode: t; c-basic-offset: 4; tab-width: 4 -*- */
/*
 * trunk
 * Copyright (C) Eoin McMahon 2010 <eoinmcmahon0@AT@gmail.com>
	 * 
 * trunk is free software: you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
	 * 
 * trunk is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include "view-row.hpp"

/*ViewRow::ViewRow() :
	Data(),
	HBox(false, 10),
	index(),
	v_s_cols(Data::n_v_s_cols),
	v_b_cols(Data::n_v_b_cols),
	uuid(),
	vm(Glib::ustring(("Name")), Gtk::PACK_SHRINK),
	status(Glib::ustring(("Status")), Gtk::PACK_SHRINK),
	vrdp(Glib::ustring(("PORT")), Gtk::PACK_SHRINK),
	hardoff(Glib::ustring("Power Off")),
	softoff(Glib::ustring("Request Power Off")),
	save(Glib::ustring("Save")),
	pause(Glib::ustring("Pause")),
	resume(Glib::ustring("Resume")),
	start(Glib::ustring("Start")),
	console(Glib::ustring("Open Console")),
	autostart(Glib::ustring(("")), false),
	buffer(Glib::ustring("")),
	wlist(),
	maxheight(0),
	widths(),
	widgets(),
	child_action()
	{
		pack_start(vm);
		pack_start(status);
		pack_start(vrdp);
		pack_start(hardoff);
		pack_start(softoff);
		pack_start(save);
		pack_start(pause);
		pack_start(resume);
		pack_start(start);
		pack_start(console);
		pack_start(autostart);
		pack_end(buffer);
		
		widgets.push_back(&vm);
		widgets.push_back(&status);
		widgets.push_back(&vrdp);
		widgets.push_back(&hardoff);
		widgets.push_back(&softoff);
		widgets.push_back(&save);
		widgets.push_back(&pause);
		widgets.push_back(&resume);
		widgets.push_back(&start);
		widgets.push_back(&console);
		widgets.push_back(&autostart);
		widgets.push_back(&buffer);
		
		vector<Gtk::Widget*>::iterator it;
		for ( it = widgets.begin() ;
		it != widgets.end() ;
		it++)
		{
			widths.push_back((*it)->get_width());
			maxheight = MAX(maxheight, (*it)->get_height());
			}
			// no parent so no report of sizes sent
			}*/

ViewRow::ViewRow(ModelRow  & source) :
	Data(),
	HBox(false, hpadding),
	pSource(&source),
	index(),
	v_s_cols(Data::n_v_s_cols),
	v_b_cols(Data::n_v_b_cols),
	uuid(source.get_str_value(Data::uuid)),
	mname(source.get_str_value(name)),
	mstatus(source.get_str_value(Data::status)),
	mport(source.get_str_value(port)),
	mautostart(),
	vm(make_markup(mname + " "), Gtk::ALIGN_LEFT),
	status(make_markup(mstatus + " "), Gtk::ALIGN_LEFT),
	vrdp(make_markup(mport + " "), Gtk::ALIGN_LEFT),
	hardoff(make_markup(Glib::ustring("Hard Power Off "))),
	softoff(make_markup(Glib::ustring("Soft Power Off "))),
	save(make_markup(Glib::ustring("Save "))),
	pause(make_markup(Glib::ustring("Pause "))),
	start(make_markup(Glib::ustring("Start "))),
	console(make_markup(Glib::ustring("Open Console "))),
	autostart(make_markup(mautostart), false),
	buffer(Glib::ustring("")),
	wlist(),
	maxheight(0),
	widths(),
	widgets(),
	pModelRow(&source),
	child_action(),
	pOld_action()
		
{
	
	child_action.sa_handler = &ViewRow::sigchld_hdl;
	if (sigaction(SIGCHLD, &child_action, pOld_action) <0 )
	{
		perror("Couldn't set sigaction for SIGCHLD in ViewRow");
	}
	hardoff.property_sensitive().set_value(source.get_boo_value(kill));
	softoff.property_sensitive().set_value(source.get_boo_value(acpi));
	save.property_sensitive().set_value(source.get_boo_value(Data::save));
	
	bool pause_flag = source.get_boo_value(Data::pause);
	bool resume_flag = source.get_boo_value(Data::resume);
	bool pause_active = (!pause_flag) && (resume_flag);
	bool pause_sensitive = ((!pause_flag) && (resume_flag)) ||
		((pause_flag) && (!resume_flag));
	pause.set_active(pause_active);
	(dynamic_cast<Gtk::Label * >(pause.get_child()))->
		set_markup(make_markup(
							   (pause.get_active() ? 
								Glib::ustring("Resume ") :
								Glib::ustring("Pause ")	)));
	pause.property_sensitive().set_value(pause_sensitive);
	
	start.property_sensitive().set_value(source.get_boo_value(Data::start));
	console.property_sensitive().set_value(source.get_boo_value(Data::console));
	autostart.set_active(source.get_boo_value(Data::autostart));
	autostart.set_label(source.get_str_value(Data::autostartstatus));
	Data::STR vrdpno = source.get_str_value(Data::port);
	bool i_have_vrdp_number = (!(vrdpno==("") || vrdpno==("none") ||
								 vrdpno==("off")));
	autostart.property_sensitive().set_value(i_have_vrdp_number);
	//	cout << "ViewRow added named " << vm.get_label() << endl;
	
	
	//~ Glib::RefPtr<Gtk::RcStyle> viewStyle = console.get_modifier_style();
	//~ cout<<"["<<viewStyle->get_bg(Gtk::STATE_NORMAL).get_red_p()<<","
		//~ <<viewStyle->get_bg(Gtk::STATE_NORMAL).get_green_p()<<","
		//~ <<viewStyle->get_bg(Gtk::STATE_NORMAL).get_blue_p()<<"]"<<endl;
	//~ Gdk::Color gold("gold");
	//~ cout << (console.get_colormap()->alloc_color(gold) ? "true" : "false")<<endl;
	//~ viewStyle->set_bg(Gtk::STATE_ACTIVE, gold);
	//~ viewStyle->set_bg(Gtk::STATE_INSENSITIVE, gold);
	//~ viewStyle->set_bg(Gtk::STATE_PRELIGHT, gold);
	//~ viewStyle->set_bg(Gtk::STATE_NORMAL, gold);
	//~ viewStyle->set_bg(Gtk::STATE_SELECTED, gold);
	//~ viewStyle->set_base(Gtk::STATE_SELECTED, gold);
	//~ cout<<"["<<viewStyle->get_bg(Gtk::STATE_NORMAL).get_red_p()<<","
		//~ <<viewStyle->get_bg(Gtk::STATE_NORMAL).get_green_p()<<","
		//~ <<viewStyle->get_bg(Gtk::STATE_NORMAL).get_blue_p()<<"]"<<endl;
	//~ console.modify_style(viewStyle);
	
	vm.set_use_markup();
	status.set_use_markup();
	vrdp.set_use_markup();
	(dynamic_cast<Gtk::Label * >(start.get_child()))->set_use_markup();
	(dynamic_cast<Gtk::Label * >(console.get_child()))->set_use_markup();
	(dynamic_cast<Gtk::Label * >(softoff.get_child()))->set_use_markup();
	(dynamic_cast<Gtk::Label * >(hardoff.get_child()))->set_use_markup();
	(dynamic_cast<Gtk::Label * >(pause.get_child()))->set_use_markup();
	(dynamic_cast<Gtk::Label * >(save.get_child()))->set_use_markup();
	(dynamic_cast<Gtk::Label * >(autostart.get_child()))->set_use_markup();
	
	
	
	//~ Gtk::VSeparator * pVSeparatorvm = Gtk::manage( new Gtk::VSeparator);
	//~ pack_start(vm);
	//~ pack_start(*pVSeparatorvm);
	//~ Gtk::VSeparator * pVSeparatorstatus = Gtk::manage( new Gtk::VSeparator);
	//~ pack_start(status);
	//~ pack_start(*pVSeparatorstatus);
	//~ Gtk::VSeparator * pVSeparatorvrdp = Gtk::manage( new Gtk::VSeparator);
	//~ pack_start(vrdp);
	//~ pack_start(*pVSeparatorvrdp);
	//~ Gtk::VSeparator * pVSeparatorstart = Gtk::manage( new Gtk::VSeparator);
	//~ pack_start(start);
	//~ pack_start(*pVSeparatorstart);
	//~ Gtk::VSeparator * pVSeparatorconsole = Gtk::manage( new Gtk::VSeparator);
	//~ pack_start(console);
	//~ pack_start(*pVSeparatorconsole);
	//~ Gtk::VSeparator * pVSeparatorsoftoff = Gtk::manage( new Gtk::VSeparator);
	//~ pack_start(softoff);
	//~ pack_start(*pVSeparatorsoftoff);
	//~ Gtk::VSeparator * pVSeparatorhardoff = Gtk::manage( new Gtk::VSeparator);
	//~ pack_start(hardoff);
	//~ pack_start(*pVSeparatorhardoff);
	//~ Gtk::VSeparator * pVSeparatorpause = Gtk::manage( new Gtk::VSeparator);
	//~ pack_start(pause);
	//~ pack_start(*pVSeparatorpause);
	//~ Gtk::VSeparator * pVSeparatorsave = Gtk::manage( new Gtk::VSeparator);
	//~ pack_start(save);
	//~ pack_start(*pVSeparatorsave);
	//~ pack_start(autostart);
	//~ pack_start(buffer);
	
		Gtk::VSeparator * pVSeparatora = Gtk::manage( new Gtk::VSeparator);
	Gtk::VSeparator * pVSeparatorb = Gtk::manage( new Gtk::VSeparator);
	Gtk::VSeparator * pVSeparatorc = Gtk::manage( new Gtk::VSeparator);
	Gtk::VSeparator * pVSeparatord = Gtk::manage( new Gtk::VSeparator);
	Gtk::VSeparator * pVSeparatore = Gtk::manage( new Gtk::VSeparator);
	Gtk::VSeparator * pVSeparatorf = Gtk::manage( new Gtk::VSeparator);
	Gtk::VSeparator * pVSeparatorg = Gtk::manage( new Gtk::VSeparator);
	Gtk::VSeparator * pVSeparatorh = Gtk::manage( new Gtk::VSeparator);
	Gtk::VSeparator * pVSeparatori = Gtk::manage( new Gtk::VSeparator);
	
	pack_start(vm, false, false);
	pack_start(*pVSeparatora, false, false);
	pack_start(status, false, false);
	pack_start(*pVSeparatorb, false, false);
	pack_start(vrdp, false, false);
	pack_start(*pVSeparatorc, false, false);
	pack_start(start, false, false);
	pack_start(*pVSeparatord, false, false);
	pack_start(console, false, false);
	pack_start(*pVSeparatore, false, false);
	pack_start(softoff, false, false);
	pack_start(*pVSeparatorf, false, false);
	pack_start(hardoff, false, false);
	pack_start(*pVSeparatorg, false, false);
	pack_start(pause, false, false);
	pack_start(*pVSeparatorh, false, false);
	pack_start(save, false, false);
	pack_start(*pVSeparatori, false, false);
	pack_start(autostart, false, false);
	pack_start(buffer, false, false);
	
	widgets.push_back(&vm);
	widgets.push_back(&status);
	widgets.push_back(&vrdp);
	widgets.push_back(&start);
	widgets.push_back(&console);
	widgets.push_back(&softoff);
	widgets.push_back(&hardoff);
	widgets.push_back(&pause);
	widgets.push_back(&save);
	widgets.push_back(&autostart);
	widgets.push_back(&buffer);
	
	set_resize_mode(Gtk::RESIZE_IMMEDIATE);
	show_all_children ();
	//check_resize();
	vector<Gtk::Widget*>::iterator it;
	//	cout << "Widths: ";
	for ( it = widgets.begin() ;
		 it != widgets.end() ;
		 it++/*, cout << ", "*/)
	{
		widths.push_back((*it)->size_request().width);
		//cout << (*it)->size_request().width;
		maxheight = MAX(maxheight, (*it)->size_request().height);
	}
	//	cout << "height ="<<maxheight<<endl;
	// report sizes to parent here
	vector<int> * pWidth = & widths;
	// connection not made in parent yet
	//emit_width_changed_signal(this->uuid, pWidth, maxheight);
	
	//parent will connect width ordered signal when it creates this:
	//~ parent.width_ordered_signal().connect(
	//~ sigc::mem_fun(*this, &ViewRow::on_width_ordered_signal));
	// connect to ModelRow row changed signals:
	//~ source.STR_changed_signal().connect( sigc::mem_fun(*this, &ViewRow::on_row_changed_STR));
	//~ source.BOO_changed_signal().connect( sigc::mem_fun(*this, &ViewRow::on_row_changed_BOO));
	console.signal_clicked()
		.connect(sigc::mem_fun(*this, &ViewRow::on_console_button_clicked));
	hardoff.signal_clicked()
		.connect(sigc::mem_fun(*this, &ViewRow::on_hardoff_button_clicked ));
	pause.signal_toggled()
		.connect(sigc::mem_fun(*this, &ViewRow::on_pause_button_clicked));
	start.signal_clicked()
		.connect(sigc::mem_fun(*this, &ViewRow::on_run_button_clicked));
	save.signal_clicked()
		.connect(sigc::mem_fun(*this, &ViewRow::on_save_button_clicked));
	softoff.signal_clicked()
		.connect(sigc::mem_fun(*this, &ViewRow::on_softoff_button_clicked));
	autostart.signal_toggled()
		.connect(sigc::mem_fun(*this, &ViewRow::on_autostart_toggled));
	
}

void ViewRow::get_width_changed_signal()
{
	//	cout << vm.get_label() << " has received get-width-changed" << endl;
	emit_width_changed_signal (clock(), uuid, widths, maxheight);
}

Data::STR ViewRow::get_uuid()
{
	return uuid;
}

ViewRow::type_STR_changed_signal ViewRow::STR_changed_ack_signal()
{
	return m_STR_changed_ack_signal;
}

ViewRow::type_BOO_changed_signal ViewRow::BOO_changed_ack_signal()
{
	return m_BOO_changed_ack_signal;
}

ViewRow::type_width_changed_signal ViewRow::width_changed_signal()
{
	return m_width_changed_signal;
}

void ViewRow::emit_row_changed_STR_ack(clock_t timestamp,
									   STR uuid,
									   m_s_col col,
									   STR old,
									   STR newvalue)
{
	m_STR_changed_ack_signal.emit(timestamp, uuid, col, old, newvalue);
}

void ViewRow::emit_row_changed_BOO_ack(clock_t timestamp,
									   STR uuid,
									   m_b_col col,
									   BOO old,
									   BOO newvalue)
{
	m_BOO_changed_ack_signal.emit(timestamp, uuid, col, old, newvalue);
}

void ViewRow::emit_width_changed_signal(clock_t timestamp, 
										Data::STR uuid,
										vector<int> & Width, int height)
{
	m_width_changed_signal.emit(timestamp, uuid, Width, height);
}

void ViewRow::on_row_changed_STR(clock_t timestamp,
								 STR uuid,
								 m_s_col col,
								 STR old,
								 STR newvalue)
{
	if (uuid == this->uuid)
	{
		switch (col)
		{
			case Data::name:
			{
				mname = newvalue;
				vm.set_markup(make_markup(newvalue) + " ");
			}
				break;
			case Data::status:
			{
				mstatus = newvalue;
				status.set_markup(make_markup(newvalue) + " ");
			}
				break;
			case Data::port:
			{
				mport = newvalue;
				vrdp.set_markup(make_markup(newvalue) + " ");
			}
				break;
			case Data::autostartstatus:
			{
				mautostart = newvalue;
				(dynamic_cast<Gtk::Label * >(autostart.get_child()))->
					set_markup(make_markup(newvalue) + " ");
			}
				break;
			default:
			{
			}
		}
		update_widths();
		emit_row_changed_STR_ack (timestamp, uuid, col, old, newvalue);
	}
}

void ViewRow::on_row_changed_BOO(clock_t timestamp,
								 STR uuid,
								 m_b_col col,
								 BOO old,
								 BOO newvalue)
{
	if (uuid == this->uuid)
	{
		
		switch (col)
		{
			case Data::start:
			{
				//				cout << this->vm.get_label() << " start set to " <<
				//					(newvalue?"true":"false") << endl;
				start.property_sensitive().set_value(newvalue);
				
			}
				break;
			case Data::acpi:
			{
				//				cout << this->vm.get_label() << " acpi set to " <<
				//					(newvalue?"true":"false") << endl;
				softoff.property_sensitive().set_value(newvalue);
				
			}
				break;
			case Data::kill:
			{
				//				cout << this->vm.get_label() << " hardoff set to " <<
				//					(newvalue?"true":"false") << endl;
				hardoff.property_sensitive().set_value(newvalue);
				
			}
				break;
			case Data::save:
			{
				//				cout << this->vm.get_label() << " save set to " <<
				//					(newvalue?"true":"false") << endl;
				save.property_sensitive().set_value(newvalue);
				
			}
				break;
			case Data::pause:
			{
				//				cout << this->vm.get_label() << " pause set to " <<
				//					(newvalue?"true":"false") << endl;
				
				pause.set_inconsistent(false);
				bool pause_flag = newvalue;
				bool resume_flag = pSource->get_boo_value(Data::resume);
				bool pause_active = (!pause_flag) && (resume_flag);
				bool pause_sensitive = ((!pause_flag) && (resume_flag)) ||
					((pause_flag) && (!resume_flag));
				pause.set_active(pause_active);
				(dynamic_cast<Gtk::Label * >(pause.get_child()))->
					set_markup(make_markup(
										   (pause.get_active() ? 
											Glib::ustring("Resume") :
												Glib::ustring("Pause")	)));
				pause.property_sensitive().set_value(pause_sensitive);
				
			}
				break;
			case Data::resume:
			{
				pause.set_inconsistent(false);
				bool pause_flag = pSource->get_boo_value(Data::pause);
				bool resume_flag = newvalue;
				bool pause_active = (!pause_flag) && (resume_flag);
				bool pause_sensitive = ((!pause_flag) && (resume_flag)) ||
					((pause_flag) && (!resume_flag));
				pause.set_active(pause_active);
				(dynamic_cast<Gtk::Label * >(pause.get_child()))->
					set_markup(make_markup(
										   (pause.get_active() ? 
											Glib::ustring("Resume") :
												Glib::ustring("Pause")	)));
				pause.property_sensitive().set_value(pause_sensitive);
				
			}
			
				break;
			case Data::console:
			{
				//				cout << this->vm.get_label() << " console set to " <<
				//					(newvalue?"true":"false") << endl;
				console.property_sensitive().set_value(newvalue);
				
			}
				break;
			case Data::autostart:
			{
				//				cout << this->vm.get_label() << " autostart set to " <<
				//					(newvalue?"true":"false") << endl;
				autostart.set_active(newvalue);
				
			}
				break;
			default:
			{
			}
		}
		update_widths();
		emit_row_changed_BOO_ack (timestamp, uuid, col, old, newvalue);
		
	}
}

vector<bool> ViewRow::get_button_sensitivities()
{
	vector<bool> ret;
	ret.push_back(hardoff.property_sensitive().get_value());
	ret.push_back(softoff.property_sensitive().get_value());
	ret.push_back(save.property_sensitive().get_value());
	ret.push_back(pause.property_sensitive().get_value());
	ret.push_back(start.property_sensitive().get_value());
	ret.push_back(console.property_sensitive().get_value());
	return ret;
}


void ViewRow::on_width_ordered_signal(clock_t timestamp,
									  Data::STR uuid,
									  vector<int> & Width,
									  int height)
{
	//	cout << vm.get_label() << " has received width-ordered-signal" << endl;
	vector<Gtk::Widget*>::iterator it;
	int id = 0;
	this->maxheight = height;
	for ( it = widgets.begin() ;
		 it != widgets.end() ;
		 it++, id++)
	{
		this->widths[id] = (Width)[id];
		(*it)->set_size_request((Width)[id], height);
	}
}

void ViewRow::on_console_button_clicked()
{
	Glib::ustring methodname("ViewRow::on_console_button_clicked()");
	if (this->start.property_sensitive().get_value())
	{
		//cout << "Starting machine first..." << endl;
		ViewRow::on_run_button_clicked();
	}
	Data::STR IPaddress = pModelRow->parent_host_address;
	
	
	Data::STR title = mname + " on port " + mport + " [vbManage console]";
	std::string command = "echo $$ ; rdesktop " + IPaddress + ":" + mport +
		" -T \" " + title + "\"  &";
	//cout << "Console button clicked, command is:\n" << command << endl;
	// set up pipe
	FILE * fpipe;
	
	
	char line[256];
	Glib::ustring lines("Trying to create console for ");
	lines.append(mname);
	lines.append(": response was:\n\n");
	size_t preamble = lines.size();
	std::string lin (256,0);
	
	//fork process:
	pid_t childpid = fork();
	if (childpid == 0) //child
	{
		//sleep(30);
		lines.append("IN CHILD:\n\n");
		preamble = lines.size();
		//open pipe:
		if ( !(fpipe= (FILE*)popen(command.c_str(), "r")) )
		{  // if fpipe is null
			perror("Problems with pipe");
			std::cout << "...Broken pipe" << std::endl;
		}
		while (fgets( line, sizeof line, fpipe))
		{
			lin = line;
			lines.append(line, lin.size());
			lines.append("\n");
			//cout << line << endl;
		}
		// parse returned text. open dialog if not ok.
		//
		// Disabled this popup for want of suitable diagnostic
		//
		bool response_ok = true;//Should say false
		// parse lines here
		Glib::ustring expected("Stopping \"");
		expected.append(mname);
		if (lines.find(expected) == preamble)
		{
			response_ok = true;
		}
		if ( !response_ok)
		{
			output_dialog(methodname, lines);
		}
		//pclose(fpipe);
		//cout << "Child exiting\n";
		_exit(0);
	}
	else if (childpid < 0) //failed to fork
	{
		lines.append("IN PARENT:\n\n");
		preamble = lines.size();
		lines.append("Failed to fork");
		output_dialog(methodname, lines);
		//cout << "Failed to fork\n";
	}
	else if (childpid > 0)
	{
		lines.append("IN PARENT:\n\n");
		lines.append("Made fork process, child pid =");
		char pidstr[30];
		std::sprintf(pidstr, "%d", childpid);
		lines.append(pidstr);
		lines.append("\n");
		lines.append("Exiting console handler\n");
		if (false)
			output_dialog(methodname, lines);
		//cout << "Made fork process, child pid =" << childpid << endl;
		//waitpid(childpid, NULL, 0);
		
	}
	//cout << "Exiting console handler\n";
}

void ViewRow::on_run_button_clicked()
{
	Glib::ustring methodname("ViewRow::on_run_button_clicked()");
	
	std::string command = "vboxtool start " + mname;
	//	cout << "Run button clicked, name is " + nname + " command is:\n" 
	//		<< command << endl;
	// set up pipe
	FILE * fpipe;
	
	
	char line[256];
	Glib::ustring lines("Trying to run ");
	lines.append(mname);
	lines.append(": response was:\n\n");
	size_t preamble = lines.size();
	std::string lin (256,0);
	
	
	
	//open pipe:
	if ( !(fpipe= (FILE*)popen(command.c_str(), "r")) )
	{  // if fpipe is null
		perror("Problems with pipe");
		std::cout << "..Broken pipe" << std::endl;
	}
	while (fgets( line, sizeof line, fpipe))
	{
		lin = line;
		lines.append(line, lin.size());
		lines.append("\n");
		//			cout << line << endl;
	}
	// parse returned text. open dialog if not ok.
	bool response_ok = false;
	// parse lines here
	Glib::ustring expected("Starting \"");
	expected.append(mname);
	if (lines.find(expected) == preamble)
	{
		response_ok = true;
	}
	if (!response_ok)
	{
		output_dialog(methodname, lines);
	}
	pclose(fpipe);
}




void ViewRow::on_pause_button_clicked()
{
	pause.set_sensitive(false);
	if (pause.get_active())
	{
		// has just been clicked to active, so pause
		(dynamic_cast<Gtk::Label * >(pause.get_child()))->
		set_markup(make_markup(
							   (pause.get_active() ? 
								Glib::ustring("Resume") :
								Glib::ustring("Pause")	)));
		pause.set_inconsistent(true);
		//recalculate widths
		update_widths(true);
		
		Glib::ustring methodname("ViewRow::on_pause_button_clicked()");
		
		
		std::string command = "VBoxManage controlvm " + mname + " pause";
		//	cout << "Resume button clicked, name is " + nname + " command is:\n" 
		//		<< command << endl;
		// set up pipe
		FILE * fpipe;
		
		
		char line[256];
		Glib::ustring lines("Trying to pause ");
		lines.append(mname);
		lines.append(": response was:\n\n");
		size_t preamble = lines.size();
		std::string lin (256,0);
		
		
		
		//open pipe:
		if ( !(fpipe= (FILE*)popen(command.c_str(), "r")) )
		{  // if fpipe is null
			perror("Problems with pipe");
			std::cout << "Broken pipe" << std::endl;
		}
		while (fgets( line, sizeof line, fpipe))
		{
			lin = line;
			lines.append(line, lin.size());
			lines.append("\n");
			//			cout << line << endl;
		}
		// parse returned text. open dialog if not ok.
		bool response_ok = false;
		// parse lines here
		Glib::ustring unexpected("VBOX_E_INVALID_SESSION_STATE");
		
		if (lines.find(unexpected) == Glib::ustring::npos)
		{
			response_ok = true;
		}
		if (!response_ok)
		{
			output_dialog(methodname, lines);
		}
		pclose(fpipe);
	}
	else
	{
		//has just been clicked to inactive, so resume
		(dynamic_cast<Gtk::Label * >(pause.get_child()))->
		set_markup(make_markup(
							   (pause.get_active() ? 
								Glib::ustring("Resume") :
								Glib::ustring("Pause")	)));
		pause.set_inconsistent(true);
		//recalculate widths
		update_widths(true);
		
		Glib::ustring methodname("ViewRow::on_resume_button_clicked()");
		
		std::string command = "VBoxManage controlvm " + mname + " resume";
		//	cout << "Resume button clicked, name is " + nname + " command is:\n" 
		//		<< command << endl;
		// set up pipe
		FILE * fpipe;
		
		
		char line[256];
		Glib::ustring lines("Trying to resume ");
		lines.append(mname);
		lines.append(": response was:\n\n");
		size_t preamble = lines.size();
		std::string lin (256,0);
		
		
		
		//open pipe:
		if ( !(fpipe= (FILE*)popen(command.c_str(), "r")) )
		{  // if fpipe is null
			perror("Problems with pipe");
			std::cout << "Broken pipe" << std::endl;
		}
		while (fgets( line, sizeof line, fpipe))
		{
			lin = line;
			lines.append(line, lin.size());
			lines.append("\n");
			//			cout << line << endl;
		}
		// parse returned text. open dialog if not ok.
		bool response_ok = false;
		// parse lines here
		Glib::ustring unexpected("VBOX_E_INVALID_SESSION_STATE");
		
		if (lines.find(unexpected) == Glib::ustring::npos)
		{
			response_ok = true;
		}
		if (!response_ok)
		{
			output_dialog(methodname, lines);
		}
		pclose(fpipe);
	}
	pause.set_sensitive(true);
}


void ViewRow::on_save_button_clicked()
{
	Glib::ustring methodname("ViewRow::on_save_button_clicked()");
	
	std::string command = "VBoxManage controlvm " + mname + " savestate";
	//	cout << "Resume button clicked, name is " + nname + " command is:\n" 
	//		<< command << endl;
	// set up pipe
	FILE * fpipe;
	
	
	char line[256];
	Glib::ustring lines("Trying to save ");
	lines.append(mname);
	lines.append(": response was:\n\n");
	size_t preamble = lines.size();
	std::string lin (256,0);
	
	
	
	//open pipe:
	if ( !(fpipe= (FILE*)popen(command.c_str(), "r")) )
	{  // if fpipe is null
		perror("Problems with pipe");
		std::cout << "Broken pipe" << std::endl;
	}
	while (fgets( line, sizeof line, fpipe))
	{
		lin = line;
		lines.append(line, lin.size());
		lines.append("\n");
		//			cout << line << endl;
	}
	// parse returned text. open dialog if not ok.
	bool response_ok = false;
	// parse lines here
	Glib::ustring unexpected("VBOX_E_INVALID_SESSION_STATE");
	
	if (lines.find(unexpected) == Glib::ustring::npos)
	{
		response_ok = true;
	}
	if (!response_ok)
	{
		output_dialog(methodname, lines);
	}
	pclose(fpipe);
}

void ViewRow::on_softoff_button_clicked()
{
	Glib::ustring methodname("ViewRow::on_softoff_button_clicked()");
	
	std::string command = "VBoxManage controlvm " + mname + " acpipowerbutton";
	//	cout << "Resume button clicked, name is " + nname + " command is:\n" 
	//		<< command << endl;
	// set up pipe
	FILE * fpipe;
	
	
	char line[256];
	Glib::ustring lines("Trying soft power off on ");
	lines.append(mname);
	lines.append(": response was:\n\n");
	size_t preamble = lines.size();
	std::string lin (256,0);
	
	
	
	//open pipe:
	if ( !(fpipe= (FILE*)popen(command.c_str(), "r")) )
	{  // if fpipe is null
		perror("Problems with pipe");
		std::cout << "Broken pipe" << std::endl;
	}
	while (fgets( line, sizeof line, fpipe))
	{
		lin = line;
		lines.append(line, lin.size());
		lines.append("\n");
		//			cout << line << endl;
	}
	// parse returned text. open dialog if not ok.
	bool response_ok = false;
	// parse lines here
	Glib::ustring unexpected("VBOX_E_INVALID_SESSION_STATE");
	
	if (lines.find(unexpected) == Glib::ustring::npos)
	{
		response_ok = true;
	}
	if (!response_ok)
	{
		output_dialog(methodname, lines);
	}
	pclose(fpipe);
}

void ViewRow::on_hardoff_button_clicked()
{
	Glib::ustring methodname("ViewRow::on_hardoff_button_clicked()");
	
	std::string command = "vboxtool stop " + mname;
	//	cout << "Run button clicked, name is " + nname + " command is:\n" 
	//		<< command << endl;
	// set up pipe
	FILE * fpipe;
	
	
	char line[256];
	Glib::ustring lines("Trying hard power off on ");
	lines.append(mname);
	lines.append(": response was:\n\n");
	size_t preamble = lines.size();
	std::string lin (256,0);
	
	
	
	//open pipe:
	if ( !(fpipe= (FILE*)popen(command.c_str(), "r")) )
	{  // if fpipe is null
		perror("Problems with pipe");
		std::cout << "Broken pipe" << std::endl;
	}
	while (fgets( line, sizeof line, fpipe))
	{
		
		lin = line;
		lines.append(line, lin.size());
		lines.append("\n");
		//cout << line << endl;
	}
	// parse returned text. open dialog if not ok.
	bool response_ok = false;
	// parse lines here
	Glib::ustring expected("Stopping \"");
	expected.append(mname);
	if (lines.find(expected) == preamble)
	{
		response_ok = true;
	}
	if (!response_ok)
	{
		output_dialog(methodname, lines);
	}
	pclose(fpipe);
}

void ViewRow::on_autostart_toggled()
{
	// test if active or not
	//~ cout << vm.get_label() << " autostart checkbutton: now " <<
	//~ (autostart.get_active() ? "active" : "inactive" ) <<endl;
	
	
	Glib::ustring  methodname("ViewRow::on_autostart_toggled()");
	
	
	
	
	// Open the machines.conf file, read in its data, write updated file
	vector<std::string> vbtool_names;
	vector<std::string> vbtool_ports;
	vector<std::string> mclines;
	std::string mcline;
	std::ifstream machines_conf ("/etc/vboxtool/machines.conf", ios::in);
	if (machines_conf.is_open())
	{
		while (!machines_conf.eof() )
		{
			getline(machines_conf, mcline);
			if (mcline != "")
			{
				//~ cout << "[" << mcline << "]" << endl;
				mclines.push_back(mcline);
				size_t comma;
				comma = mcline.find(',');
				vbtool_names.push_back(mcline.substr(0, comma ));
				vbtool_ports.push_back(mcline.substr(comma+1));
			}
			
		}
		machines_conf.close();
	}
	else
	{
		Glib::ustring msg("Could not open machines.conf");
		output_dialog(methodname, msg);
		//cout << "Could not open machines.conf" << endl;
	}
	
	
	
	if (autostart.get_active())
	{
		// add a line to mclines
		Glib::ustring newline = mname;
		newline += ',';
		newline += mport;
		mclines.push_back(newline);
	}
	else
	{
		// find line to remove from mclines
		vector<std::string>::iterator mclIt;
		set<vector<std::string>::iterator> delList;
		set<vector<std::string>::iterator>::iterator delIt;
		bool found = false;
		for (mclIt = mclines.begin(); mclIt != mclines.end() ; mclIt++)
		{
			if (mclIt->find(mname) == 0)
			{
				found = true;
				delList.insert(mclIt);//do not break, remove all matching lines
			}
		}
		for (delIt = delList.begin() ; delIt != delList.end() ; delIt ++)
		{
			mclines.erase(*delIt);
		}
		if (!found)
		{
			Glib::ustring msg("Failed to erase line");
			output_dialog(methodname, msg);
			//cout << "Failed to erase line" << endl;
		}
	}
	
	vector<std::string>::iterator mclIt;
	//~ cout << "mclines has " << mclines.size() << " members, Machines.conf is:"<<endl;
	//~ for (mclIt = mclines.begin(); mclIt != mclines.end() ; mclIt++)
	//~ {
	//~ cout << (*mclIt) <<endl;
	//~ }
	//~ cout << endl;
	
	// Write mclines back to file
	std::ofstream newfile("/etc/vboxtool/machines.conf", ios::out|ios::trunc);
	if (newfile.is_open())
	{
		vector<std::string>::iterator mclIt;
		for (mclIt = mclines.begin(); mclIt != mclines.end() ; mclIt++)
		{
			newfile << (*mclIt) << endl;
		}
		newfile.close();
	}
	else
	{
		Glib::ustring msg("Could not open machines.conf for writing");
		output_dialog(methodname, msg);
		//cout << "Could not open machines.conf for writing!" << endl;
	}
}


void ViewRow::output_dialog(
							Glib::ustring & main_message, 
							Glib::ustring & secondary_message)
{
	if (show_error_messages)
	{
		Gtk::MessageDialog dialog( main_message,
		false, Gtk::MESSAGE_WARNING, Gtk::BUTTONS_OK);
		dialog.set_secondary_text(secondary_message);

		int result = dialog.run();

		//Handle the response:
		switch(result)
		{
			case(Gtk::RESPONSE_OK):
			{
				std::cout << "OK clicked." << std::endl;
				break;
			}
			case(Gtk::RESPONSE_CLOSE):
			{
				std::cout << "Close button clicked." << std::endl;
				break;
			}
			default:
			{
				std::cout << "Unexpected button clicked." << std::endl;
				break;
			}
		}
	}
}

Glib::ustring ViewRow::make_markup(Glib::ustring text)
{
	return Glib::ustring(opening + fontname + middle + text + closing);
}

void ViewRow::on_font_change()
{
	//expect global value fontname to have been changed before this fn is called
	vm.set_label(make_markup(mname));
	status.set_label(make_markup(mstatus));
	vrdp.set_label(make_markup(mport));
	
	(dynamic_cast<Gtk::Label * >(hardoff.get_child()))->
		set_markup(make_markup(Glib::ustring("Hard Power Off")));
	
	(dynamic_cast<Gtk::Label * >(softoff.get_child()))->
		set_markup(make_markup(Glib::ustring("Soft Power Off")));
	
	(dynamic_cast<Gtk::Label * >(save.get_child()))->
		set_markup(make_markup(Glib::ustring("Save")));
	
	(dynamic_cast<Gtk::Label * >(pause.get_child()))->
		set_markup(make_markup(
							   (pause.get_active() ? 
								Glib::ustring("Resume") :
								Glib::ustring("Pause")	)));
	
	(dynamic_cast<Gtk::Label * >(start.get_child()))->
		set_markup(make_markup(Glib::ustring("Start")));
	
	(dynamic_cast<Gtk::Label * >(console.get_child()))->
		set_markup(make_markup(Glib::ustring("Open Console")));
	update_widths();
	
}

void ViewRow::update_widths(bool emit_signal )
{
	
	vector<Gtk::Widget*>::iterator it;
	int id = 0;
	maxheight = 0;
	int widthSoFar = 0;
	for ( it = widgets.begin() ;
			 it != widgets.end() ;
			 it++, id++)
		{
			(*it)->set_size_request();
			Gtk::Requisition requires = (*it)->size_request();
			Gtk::Allocation allocate(widthSoFar, 0, requires.width, requires.height);
			widthSoFar += requires.width;
			(*it)->size_allocate(allocate);
			this->widths[id] = requires.width;
			maxheight = MAX(maxheight, requires.height);
		}
		vector<int> * pWidth = & widths;
	if (emit_signal)
	{
		emit_width_changed_signal(clock(), this->uuid, widths, maxheight);
	}
}
